﻿'********************************************************************************
'**
'**  Titel           : 
'**  Name            : WadExport.vb
'**  Typ             : DLL
'**  Copyright       : (c)2016 Christian Meyer
'**
'**  Beschreibung    : WinAlldatNet KIS Export DLL
'**
'**  Autor           : Christian Meyer
'**  Datum           : 17.12.2016
'**  Letzte Revision : 20.12.2016
'**  Status          : 
'**
'********************************************************************************
Option Strict On
Option Explicit On

Imports System.Diagnostics

Public Class WadExport


    '********************************************************************************
    '*
    '********************************************************************************

    Public Structure ExportData
        Dim ipatid As Integer
        Dim adminid As String
        Dim patname As String
        Dim patfirstname As String
        Dim birthname As String
        Dim birthdate As String
        Dim sex As String
        Dim street As String
        Dim zipcode As String
        Dim city As String
        Dim country As String
        Dim phone_work As String
        Dim phone_athome As String
        Dim datecurrent As String
        Dim dateconsultation As String
        Dim documentname As String
        Dim documentpath As String 'Dateipfad ohne Dateinamen
        Dim documentfullpath As String 'Dateipfad mit Dateinamen
        Dim documentformat As String 'TXT, PDF, XML, HTML
        Dim documenttype As String 'TestProtocol, FindingsProtocol
    End Structure

    '********************************************************************************
    '*
    '********************************************************************************

    Private oData As ExportData
    Public Property Data As ExportData
        Get
            Return oData
        End Get
        Set(value As ExportData)
            oData = value
        End Set
    End Property

    '********************************************************************************
    '*
    '********************************************************************************

    Public Function Send(ByVal oData As ExportData) As Boolean
        Try
            Dim sText As String = ""

            sText &= "[Zusatz]" & Environment.NewLine
            sText &= "Quelle=DK_IVDK" & Environment.NewLine
            sText &= "Gruppe=" & Environment.NewLine
            sText &= "[Patient]" & Environment.NewLine
            sText &= "Patienten_ID=" & oData.adminid & Environment.NewLine
            sText &= "Titel=" & Environment.NewLine
            sText &= "Name=" & oData.patname & Environment.NewLine
            sText &= "Geburtsname=" & oData.birthname & Environment.NewLine
            sText &= "Vorname=" & oData.patfirstname & Environment.NewLine
            sText &= "Geschlecht=" & oData.sex & Environment.NewLine
            sText &= "Geburtsdatum=" & oData.birthdate & Environment.NewLine
            sText &= "SVNR_4=" & Environment.NewLine
            sText &= "[Fall]" & Environment.NewLine
            sText &= "KH_Kennzeichen=102" & Environment.NewLine
            sText &= "Aufnahmezahl=" & Environment.NewLine
            sText &= "SubPatNr=" & Environment.NewLine
            sText &= "Klinik=DK" & Environment.NewLine
            sText &= "DokLST=DKALLERG" & Environment.NewLine
            sText &= "Aufenthalt_von=" & Environment.NewLine
            sText &= "Aufenthalt_bis=" & Environment.NewLine
            sText &= "AmbKennzeichen=" & Environment.NewLine
            sText &= "[MEDOCS]" & Environment.NewLine
            sText &= "Fallnummer=" & Environment.NewLine
            sText &= "Fallart=" & Environment.NewLine
            sText &= "PID=" & oData.adminid & Environment.NewLine
            sText &= "Abgleich=" & Environment.NewLine
            sText &= "Archiv_Dok_ID=" & Environment.NewLine
            sText &= "[Dokument]" & Environment.NewLine
            sText &= "Dokumentart=KFB" & Environment.NewLine
            sText &= "Dokumentart_UG=ALERG" & Environment.NewLine
            sText &= "Beschreibung=" & Environment.NewLine
            sText &= "Dokumentdatum=" & oData.dateconsultation & Environment.NewLine
            sText &= "Dokument_ID=" & Environment.NewLine
            sText &= "Dateiformat=" & oData.documentformat & Environment.NewLine
            sText &= "Dateiname=" & oData.documentname & Environment.NewLine
            sText &= "Stylesheet=" & Environment.NewLine

            'ToDo : Dateiname entsprach auch im alten WinAlldat IVDK nicht dem geforderten Dateinamen
            '       Irgendwo in der WinalldatGraz.dll eine unbekannte Dateinamen-Konvertierungen enthalten?

            'ToDo : Für die neue .xml-Ausgabe gibt es kein Stylesheet, .pdf- oder .html-ausgabe als Alternative?

            'ToDo : Berechnung des Zeitstempels ist unbekannt und wurde solange durch einen HHmm Zeitstempel ersetzt
            Dim sTime As String = DateTime.Now.ToShortTimeString.Replace(":", "")

            Dim sFileName As String = "Winalldat_" & oData.datecurrent & sTime & ".idx"
            WriteStringToFile(IO.Path.Combine(IO.Path.Combine(GetBaseDirectory, "temp"), sFileName), sText)

            Dim sFileName2 As String = "Winalldat_" & oData.datecurrent & sTime & ".rdy"
            WriteStringToFile(IO.Path.Combine(IO.Path.Combine(GetBaseDirectory, "temp"), sFileName2), sFileName)

            Return True
        Catch
            Return False
        End Try
        Return False 'Steht nur hier, damit der Kompiler nicht meckert
    End Function

    '********************************************************************************
    '*
    '********************************************************************************

    Private Function GetBaseDirectory() As String
        Try
            Return IO.Path.GetDirectoryName(Process.GetCurrentProcess.MainModule.FileName)
        Catch
            Return ""
        End Try
    End Function

    '********************************************************************************
    '*
    '********************************************************************************

    Private Function WriteStringToFile(ByVal sFileName As String, ByVal sText As String) As Boolean
        Dim oStreamWriter As IO.StreamWriter

        If IO.File.Exists(sFileName) = True Then
            IO.File.Delete(sFileName)
        End If

        oStreamWriter = New IO.StreamWriter(sFileName, True, System.Text.Encoding.Default)

        oStreamWriter.Write(sText)
        oStreamWriter.Flush()
        oStreamWriter.Close()
        Return True

    End Function

End Class

